<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>

<body>
    <div class="container">
        <h3>User Detail</h3>
        <div>

            <label for="">Name</label>
            <input type="text" name="" id="inp-name" class="form-control">
            <label for="">UserName</label>
            <input type="text" name="" id="inp-user-name" class="form-control">
            <label for="">Email</label>
            <input type="text" name="" id="inp-email" class="form-control">
            <label for="">Address Street</label>
            <input type="text" name="" id="inp-address-street" class="form-control">
            <label for="">Address Suite</label>
            <input type="text" name="" id="inp-address-suite" class="form-control">
            <label for="">Address City</label>
            <input type="text" name="" id="inp-address-city" class="form-control">
            <label for="">ZipCode</label>
            <input type="text" name="" id="inp-address-zipcode" class="form-control">
            <label for="">Lat</label>
            <input type="text" name="" id="inp-address-geo-lat" class="form-control">
            <label for="">Lng</label>
            <input type="text" name="" id="inp-address-geo-lng" class="form-control">
            <label for="">Phone</label>
            <input type="text" name="" id="inp-phone" class="form-control">
            <label for="">Website</label>
            <input type="text" name="" id="inp-website" class="form-control">
            <label for="">Company Name</label>
            <input type="text" name="" id="inp-company-name" class="form-control">
            <label for="">Company CatchPharse</label>
            <input type="text" name="" id="inp-company-catch" class="form-control">
            <label for="">Company Bs</label>
            <input type="text" name="" id="inp-company-bs" class="form-control">
            <div class="mt-3">
                <button id="btn-update" class="btn btn-success">Update</button>
                <button id="btn-huy" class="btn btn-warning">Hủy</button>
            </div>

        </div>
    </div>
    <hr>
    <hr>
    <hr>


</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    var gLink = window.location.href
    var gUrl = new URL(gLink);
    var gId = gUrl.searchParams.get("id");
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        console.log(gId);
        onLoadPage();

        $("#btn-update").on("click", function () {
            goiApiUpdate();
        })
        $("#btn-huy").on("click", function () {
            window.location.href = "task35.20.html";
        })

    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onLoadPage() {
        $.ajax({
            url: gBASE_URL + gId,
            type: "GET",
            success: function (res) {
                console.log(res);
                fillDataInputUser(res);
            },
            error: function (error) {
                console.log(error.status);
            }
        })

    }
    function onBtnupdateUser() {
        var vUserObj = {
            name: "",
            username: "",
            email: "",
            street: "",
            suite: "",
            city: "",
            zipcode: "",
            lat: "",
            lng: "",
            phone: "",
            website: "",
            catchPhrase: "",
            bs: "",
            name: "",

        }
        getDataUser(vUserObj);
        return vUserObj;

    }
    function goiApiUpdate() {
        var vObjUser = onBtnupdateUser();
        $.ajax({
            url: gBASE_URL + gId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(vObjUser),
            success: function () {
                alert("update thành công!");
                // window.location.href = "task35.20.html";
            },
            error: function () {
                console.log(error.status);
            }


        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function fillDataInputUser(paramRes) {
        $("#inp-name").val(paramRes.name);
        $("#inp-user-name").val(paramRes.username);
        $("#inp-email").val(paramRes.email);
        $("#inp-address-street").val(paramRes.address.street);
        $("#inp-address-suite").val(paramRes.address.suite);
        $("#inp-address-city").val(paramRes.address.city);
        $("#inp-address-zipcode").val(paramRes.address.zipcode);
        $("#inp-address-geo-lat").val(paramRes.address.geo.lat);
        $("#inp-address-geo-lng").val(paramRes.address.geo.lng);
        $("#inp-phone").val(paramRes.phone);
        $("#inp-website").val(paramRes.website);
        $("#inp-company-name").val(paramRes.company.name);
        $("#inp-company-catch").val(paramRes.company.catchPhrase);
        $("#inp-company-bs").val(paramRes.company.bs);

    }
    function getDataUser(paramUser) {
        paramUser.name = $("#inp-name").val().trim();
        paramUser.username = $("#inp-user-name").val().trim();
        paramUser.email = $("#inp-email").val().trim();
        paramUser.street = $("#inp-address-street").val().trim();
        paramUser.suite = $("#inp-address-suite").val().trim();
        paramUser.city = $("#inp-address-city").val().trim();
        paramUser.zipcode = $("#inp-address-zipcode").val().trim();
        paramUser.lat = $("#inp-address-geo-lat").val().trim();
        paramUser.lng = $("#inp-address-geo-lng").val().trim();
        paramUser.phone = $("#inp-phone").val().trim();
        paramUser.website = $("#inp-website").val().trim();
        paramUser.name = $("#inp-company-name").val().trim();
        paramUser.catchPhrase = $("#inp-company-catch").val().trim();
        paramUser.bs = $("#inp-company-bs").val().trim();

    }
</script>

</html>